/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.unis.policy.info.modular.mlpFirstDraftCollectOrg.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.unis.common.enums.CommonSortOrderEnum;
import com.unis.common.exception.CommonException;
import com.unis.common.page.CommonPageRequest;
import com.unis.policy.info.modular.mlpFirstDraftCollectOrg.entity.MlpFirstDraftCollectOrg;
import com.unis.policy.info.modular.mlpFirstDraftCollectOrg.mapper.MlpFirstDraftCollectOrgMapper;
import com.unis.policy.info.modular.mlpFirstDraftCollectOrg.param.MlpFirstDraftCollectOrgAddParam;
import com.unis.policy.info.modular.mlpFirstDraftCollectOrg.param.MlpFirstDraftCollectOrgEditParam;
import com.unis.policy.info.modular.mlpFirstDraftCollectOrg.param.MlpFirstDraftCollectOrgIdParam;
import com.unis.policy.info.modular.mlpFirstDraftCollectOrg.param.MlpFirstDraftCollectOrgPageParam;
import com.unis.policy.info.modular.mlpFirstDraftCollectOrg.service.MlpFirstDraftCollectOrgService;

import java.util.List;

/**
 * 中长期规划管理-初稿意见反馈-组织架构Service接口实现类
 *
 * @author QSHan
 * @date  2024/04/18 20:09
 **/
@Service
public class MlpFirstDraftCollectOrgServiceImpl extends ServiceImpl<MlpFirstDraftCollectOrgMapper, MlpFirstDraftCollectOrg> implements MlpFirstDraftCollectOrgService {

    @Override
    public Page<MlpFirstDraftCollectOrg> page(MlpFirstDraftCollectOrgPageParam mlpFirstDraftCollectOrgPageParam) {
        QueryWrapper<MlpFirstDraftCollectOrg> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isAllNotEmpty(mlpFirstDraftCollectOrgPageParam.getSortField(), mlpFirstDraftCollectOrgPageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(mlpFirstDraftCollectOrgPageParam.getSortOrder());
            queryWrapper.orderBy(true, mlpFirstDraftCollectOrgPageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(mlpFirstDraftCollectOrgPageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByAsc(MlpFirstDraftCollectOrg::getId);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(MlpFirstDraftCollectOrgAddParam mlpFirstDraftCollectOrgAddParam) {
        MlpFirstDraftCollectOrg mlpFirstDraftCollectOrg = BeanUtil.toBean(mlpFirstDraftCollectOrgAddParam, MlpFirstDraftCollectOrg.class);
        this.save(mlpFirstDraftCollectOrg);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(MlpFirstDraftCollectOrgEditParam mlpFirstDraftCollectOrgEditParam) {
        MlpFirstDraftCollectOrg mlpFirstDraftCollectOrg = this.queryEntity(mlpFirstDraftCollectOrgEditParam.getId());
        BeanUtil.copyProperties(mlpFirstDraftCollectOrgEditParam, mlpFirstDraftCollectOrg);
        this.updateById(mlpFirstDraftCollectOrg);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<MlpFirstDraftCollectOrgIdParam> mlpFirstDraftCollectOrgIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(mlpFirstDraftCollectOrgIdParamList, MlpFirstDraftCollectOrgIdParam::getId));
    }

    @Override
    public MlpFirstDraftCollectOrg detail(MlpFirstDraftCollectOrgIdParam mlpFirstDraftCollectOrgIdParam) {
        return this.queryEntity(mlpFirstDraftCollectOrgIdParam.getId());
    }

    @Override
    public MlpFirstDraftCollectOrg queryEntity(String id) {
        MlpFirstDraftCollectOrg mlpFirstDraftCollectOrg = this.getById(id);
        if(ObjectUtil.isEmpty(mlpFirstDraftCollectOrg)) {
            throw new CommonException("中长期规划管理-初稿意见反馈-组织架构不存在，id值为：{}", id);
        }
        return mlpFirstDraftCollectOrg;
    }
}
